#ifndef _PARTICLEOBJECT_H
#define _PARTICLEOBJECT_H

#include <vector>
#include <GL/glfw.h>

#define PARTICLESIZE 0.05
#define PARTICLECOUNT 800

typedef struct ParticleStruct
{
  float x,y,z;    // Position
  float xv,yv,zv; // Movement vector
  bool Active,Type;
  int Source;
}
PStruct;

class ParticleManager
{
public:
  ParticleManager();
  bool LoadTexture(char* fName);
  void Add(float x, float y, float z, float xv, float yv, float zv);
  void Render(double TBMVal);

private:
  std::vector<PStruct> Bits;
  GLuint ParticleTex;
  int Current;
};


#endif
